from typing import List
from BuildingElement import BuildingElement

import NemAll_Python_BasisElements as AllplanBasisElements
import NemAll_Python_BaseElements as AllplanBaseElements
import NemAll_Python_Geometry as AllplanGeo
import NemAll_Python_IFW_Input as AllplanIFW

def check_allplan_version(build_ele, version):
    """
    Check the current Allplan version

    Args:
        build_ele: the building element.
        version:   the current Allplan version

    Returns:
        True/False if version is supported by this script
    """

    # Delete unused arguments
    del build_ele
    del version

    # Support all versions
    return True

def create_interactor(coord_input: AllplanIFW.CoordinateInput, pyp_path: str, str_table_service):
    """
    Start interactor
    Args:
        coord_input: coordinate input
        pyp_path: path of the pyp file
        str_table_service: string table service
    """

    return StripFoundationClass()

class StripFoundationClass():
    def process_mouse_msg(self,
                          mouse_msg: int,
                          pnt      : AllplanGeo.Point2D,
                          msg_info : AllplanIFW.AddMsgInfo) -> bool:
        """
        Handles the process mouse message event

        Args:
            mouse_msg: the mouse message.
            pnt      : the input point.
            msg_info : additional message info.

        Returns:
            True/False for success.
        """
        return True

    def on_cancel_function(self) -> bool:
        """
        Cancel the input function

        Returns:
            True/False for success.
        """
        return True

    def on_mouse_leave(self):
        """
        Handles the mouse leave event
        """
        pass

    def on_preview_draw(self):
        """
        Handles the preview draw event
        """
        pass